Imports System.Drawing
Imports System.ComponentModel
Imports System.Security.Permissions
Public Class CustomComboBox
    Inherits ComboBox
    <SecurityPermissionAttribute( _
    SecurityAction.LinkDemand, Flags:=SecurityPermissionFlag.UnmanagedCode)> _
    Protected Overrides Function ProcessKeyMessage(ByRef m As Message) As Boolean
        '       ComboBox .
        Return ProcessKeyEventArgs(m)
    End Function
    Public Class DataGridComboBoxColumn
        Inherits DataGridColumnStyle
        '  Combo   Public      Class   
        '   Class      
        Public customComboBox1 As New CustomComboBox()
        Private isEditing As Boolean
        '   
        Protected Overrides Sub SetDataGridInColumn(ByVal value As DataGrid)
            MyBase.SetDataGridInColumn(value)
            If Not (customComboBox1.Parent Is Nothing) Then
                customComboBox1.Parent.Controls.Remove(customComboBox1)
            End If
            If Not (value Is Nothing) Then
                value.Controls.Add(customComboBox1)
            End If
        End Sub
        Public Sub New()
            customComboBox1.Visible = False
        End Sub
        Private Sub ComboBoxTextChanged(ByVal sender As Object, ByVal e As EventArgs)
            RemoveHandler customComboBox1.SelectionChangeCommitted, AddressOf ComboBoxTextChanged
            Me.isEditing = True
            MyBase.ColumnStartedEditing(customComboBox1)
        End Sub
        Protected Overloads Overrides Sub Edit(ByVal [source] As CurrencyManager, _
                ByVal rowNum As Integer, _
                ByVal bounds As Rectangle, _
                ByVal [readOnly] As Boolean, _
                ByVal displayText As String, _
                ByVal cellIsVisible As Boolean)
            '  Function          
            Dim value As String = GetText(GetColumnValueAtRow([source], rowNum))
            If cellIsVisible Then
                customComboBox1.Bounds = New Rectangle _
                (bounds.X + 2, bounds.Y + 2, bounds.Width - 4, bounds.Height - 4)
                customComboBox1.Text = value
                customComboBox1.Visible = True
                AddHandler customComboBox1.SelectionChangeCommitted, AddressOf ComboBoxTextChanged
            Else
                customComboBox1.Text = value
                customComboBox1.Visible = False
            End If
            If customComboBox1.Visible Then
                DataGridTableStyle.DataGrid.Invalidate(bounds)
            End If
            customComboBox1.SelectedIndex = customComboBox1.FindStringExact(value)
            customComboBox1.Text = value
            customComboBox1.Focus()
        End Sub
        Private Function GetText(ByVal val As Object) As String
            If Not IsDBNull(val) Then
                Return val.ToString()
            Else
                Return String.Empty
            End If
        End Function
        '     
        Protected Overrides Function GetPreferredSize(ByVal g As Graphics, ByVal value As Object) As Size
            Return New Size(100, customComboBox1.PreferredHeight + 4)
        End Function
        '      
        Protected Overrides Function GetMinimumHeight() As Integer
            Return customComboBox1.PreferredHeight + 4
        End Function
        '     
        Protected Overrides Function GetPreferredHeight(ByVal g As Graphics, ByVal value As Object) As Integer
            Return customComboBox1.PreferredHeight + 4
        End Function
        '     DataGrid
        Protected Overloads Overrides Sub Paint(ByVal g As Graphics, ByVal bounds As Rectangle, _
            ByVal [source] As CurrencyManager, ByVal rowNum As Integer)
            Paint(g, bounds, [source], rowNum, False)
        End Sub
        '     DataGrid        
        Protected Overloads Overrides Sub Paint(ByVal g As Graphics, _
            ByVal bounds As Rectangle, ByVal [source] As CurrencyManager, _
            ByVal rowNum As Integer, ByVal alignToRight As Boolean)
            Paint(g, bounds, [source], rowNum, Brushes.Red, _
                Brushes.Blue, alignToRight)
        End Sub
        '    
        Protected Overrides Function Commit(ByVal dataSource As CurrencyManager, ByVal rowNum As Integer) As Boolean
            customComboBox1.Bounds = Rectangle.Empty
            RemoveHandler customComboBox1.SelectionChangeCommitted, AddressOf ComboBoxTextChanged
            If Not isEditing Then
                Return True
            End If
            isEditing = False
            Try
                Dim value As String = customComboBox1.Text
                SetColumnValueAtRow(dataSource, rowNum, value)
            Catch
            End Try
            Invalidate()      '     
            Return True
        End Function
        '           
        Protected Overrides Sub Abort(ByVal rowNum As Integer)
            isEditing = False
            RemoveHandler customComboBox1.SelectionChangeCommitted, AddressOf ComboBoxTextChanged
            Invalidate()             '     
        End Sub
        '       
        Protected Overloads Overrides Sub Paint(ByVal g As Graphics, _
            ByVal bounds As Rectangle, ByVal [source] As CurrencyManager, _
            ByVal rowNum As Integer, ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, ByVal alignToRight As Boolean)
            Dim txt As String = GetText(GetColumnValueAtRow([source], rowNum))
            Dim rect As Rectangle = bounds
            g.FillRectangle(backBrush, rect)
            rect.Offset(0, 2)
            rect.Height -= 2
            Dim sf As New StringFormat
            g.DrawString(txt, Me.DataGridTableStyle.DataGrid.Font, foreBrush, _
                RectangleF.FromLTRB(rect.X, rect.Y, rect.Right, rect.Bottom))
        End Sub
    End Class
End Class
