Imports System.Data
Imports System.Data.OleDb
Public Class Info
    Dim InfoConnection As OleDbConnection
    Dim InfoCommand As OleDbCommand
    Dim InfoAdapter As OleDbDataAdapter
    Dim InfoTable As DataTable
    Dim InfoManager As CurrencyManager
    Dim InfoState As String
    Dim InfoBookmark As Integer
    Private Sub SetState(ByVal AppState As String)
        InfoState = AppState
        Select Case AppState
            Case "View"
                btnFirst.Enabled = True
                btnPrevious.Enabled = True
                btnNext.Enabled = True
                btnLast.Enabled = True
                btnEdit.Enabled = True
                btnSave.Enabled = False
                btnCancel.Enabled = False
                btnAdd.Enabled = True
                btnDelete.Enabled = True
                btnPrint.Enabled = True
                btnExit.Enabled = True
                txtFirstName.ReadOnly = True
                txtLastName.ReadOnly = True
                txtHomePhone.ReadOnly = True
                DateTimePicker1.Enabled = False
                btnLoadPhoto.Enabled = False
                txtGrade.ReadOnly = True
            Case "Edit", "Add"
                btnFirst.Enabled = False
                btnPrevious.Enabled = False
                btnNext.Enabled = False
                btnLast.Enabled = False
                btnEdit.Enabled = False
                btnSave.Enabled = True
                btnCancel.Enabled = True
                btnAdd.Enabled = False
                btnDelete.Enabled = False
                btnPrint.Enabled = False
                btnExit.Enabled = False
                txtFirstName.ReadOnly = False
                txtLastName.ReadOnly = False
                txtHomePhone.ReadOnly = False
                DateTimePicker1.Enabled = True
                btnLoadPhoto.Enabled = True
                txtGrade.ReadOnly = False
        End Select
        txtFirstName.Focus()
    End Sub
    Private Sub frmInfo_FormClosing(ByVal sender As Object, _
     ByVal e As System.Windows.Forms. _
     FormClosingEventArgs) Handles Me.FormClosing
        If InfoState = "Edit" Or InfoState = "Add" Then
            MessageBox.Show("   ", "", _
            MessageBoxButtons.OK, MessageBoxIcon.Information)
            e.Cancel = True
        Else
            Try
                Dim InfoAdapterCommands As New OleDbCommandBuilder(InfoAdapter)
                InfoAdapter.Update(InfoTable)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "    ", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
            InfoConnection.Close()
            InfoCommand.Dispose()
            InfoAdapter.Dispose()
            InfoTable.Dispose()
        End If
    End Sub
    Private Sub Info_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        InfoConnection = New OleDbConnection _
        ("Provider=Microsoft.Jet.OLEDB.4.0; Data Source = " _
        + Application.StartupPath + "\..\..\Informations.mdb")
        InfoConnection.Open()
        InfoCommand = New OleDbCommand _
        ("SELECT * FROM Information ORDER BY LastName", InfoConnection)
        InfoAdapter = New OleDbDataAdapter()
        InfoAdapter.SelectCommand = InfoCommand
        InfoTable = New DataTable()
        InfoAdapter.Fill(InfoTable)
        txtFirstName.DataBindings.Add("Text", InfoTable, "FirstName")
        txtLastName.DataBindings.Add("Text", InfoTable, "LastName")
        txtHomePhone.DataBindings.Add("Text", InfoTable, "HomePhone")
        txtGrade.DataBindings.Add("Text", InfoTable, "Grade")
        DateTimePicker1.DataBindings.Add("Text", InfoTable, "BirthDate")
        lblPhotoFile.DataBindings.Add("Text", InfoTable, "PictureFile")
        InfoManager = DirectCast(Me.BindingContext(InfoTable), CurrencyManager)
        Call SetState("View")
        Call ShowPhoto()
    End Sub
    Private Sub ShowPhoto()
        If lblPhotoFile.Text <> "" Then
            Try
                PictureBox1.Image = Image.FromFile(lblPhotoFile.Text)
            Catch ex As Exception
                MessageBox.Show(ex.Message, _
                "   ", MessageBoxButtons.OK, _
                MessageBoxIcon.Error)
            End Try
        Else
            PictureBox1.Image = Nothing
        End If
    End Sub
    Private Sub PrintInfo(ByVal sender As Object _
    , ByVal e As Drawing.Printing.PrintPageEventArgs)
        Dim MyPen As Pen = New Pen(Color.Black, 3)
        e.Graphics.DrawRectangle _
        (MyPen, e.MarginBounds.X, e.MarginBounds.Y, 200, 350)
        Dim MyFont As Font = New Font("Arial", 12, FontStyle.Bold)
        Dim S As String = "     "
        Dim SSize As SizeF = e.Graphics.MeasureString(S, MyFont)
        e.Graphics.DrawString(S, MyFont, Brushes.Black _
        , e.MarginBounds.X + CInt(0.5 * (200 - SSize.Width)) _
        , e.MarginBounds.Y + 15)
        e.Graphics.DrawImage(PictureBox1.Image, _
        e.MarginBounds.X + 25, e.MarginBounds.Y + 50, 150, 200)
        e.HasMorePages = False
        MyFont = New Font("Arial", 14)
        Dim Y As Integer = e.MarginBounds.Y + 260
        S = txtFirstName.Text
        SSize = e.Graphics.MeasureString(S, MyFont)
        e.Graphics.DrawString(S, MyFont, Brushes.Black, _
        e.MarginBounds.X + CInt(0.5 * (200 - SSize.Width)), Y)
        Y += CInt(MyFont.GetHeight(e.Graphics))
        S = txtLastName.Text
        SSize = e.Graphics.MeasureString(S, MyFont)
        e.Graphics.DrawString(S, MyFont, Brushes.Black, _
        e.MarginBounds.X + CInt(0.5 * (200 - SSize.Width)), Y)
        Y += CInt(MyFont.GetHeight(e.Graphics))
        S = txtGrade.Text
        SSize = e.Graphics.MeasureString(S, MyFont)
        e.Graphics.DrawString(S, MyFont, Brushes.Black, _
        e.MarginBounds.X + CInt(0.5 * (200 - SSize.Width)), Y)
    End Sub
    Private Sub txtFirstName_KeyPress(ByVal sender As _
    System.Object, ByVal e As System.Windows.Forms. _
    KeyPressEventArgs) Handles txtFirstName.KeyPress
        If e.KeyChar = ControlChars.Cr Then
            txtLastName.Focus()
        End If
    End Sub
    Private Sub btnFirst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFirst.Click
        InfoManager.Position = 0
        Call ShowPhoto()
    End Sub
    Private Sub btnPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrevious.Click
        InfoManager.Position -= 1
        Call ShowPhoto()
    End Sub
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        InfoManager.Position += 1
        Call ShowPhoto()
    End Sub
    Private Sub btnLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLast.Click
        InfoManager.Position = InfoManager.Count - 1
        Call ShowPhoto()
    End Sub
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        InfoBookmark = InfoManager.Position
        Call SetState("Add")
        InfoManager.AddNew()
        PictureBox1.Image = Nothing
        lblPhotoFile.Text = ""
    End Sub
    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        InfoManager.CancelCurrentEdit()
        If InfoState = "Add" Then
            InfoManager.Position = InfoBookmark
        End If
        Call ShowPhoto()
        Call SetState("View")
    End Sub
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If txtLastName.Text.Trim = "" Then
            MessageBox.Show("   ", " ", _
            MessageBoxButtons.OK, MessageBoxIcon.Information)
            txtLastName.Focus()
            Exit Sub
        End If
        Dim SavedItem As String = txtLastName.Text
        Dim SavedRow As Integer
        InfoManager.EndCurrentEdit()
        InfoTable.DefaultView.Sort = "LastName"
        SavedRow = InfoTable.DefaultView.Find(SavedItem)
        InfoManager.Position = SavedRow
        Call ShowPhoto()
        Call SetState("View")
    End Sub
    Private Sub btnEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEdit.Click
        Call SetState("Edit")
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Close()
    End Sub
    Private Sub btnLoadPhoto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPhoto.Click
        Try
            If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                lblPhotoFile.Text = OpenFileDialog1.FileName
                Call ShowPhoto()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "  ", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        Dim InfoDocument As Drawing.Printing.PrintDocument
        InfoDocument = New Drawing.Printing.PrintDocument()
        InfoDocument.DocumentName = "Info"
        AddHandler InfoDocument.PrintPage, AddressOf Me.PrintInfo
        Dim SavedPosition As Integer = InfoManager.Position
        PrintPreviewDialog1.Document = InfoDocument
        PrintPreviewDialog1.ShowDialog()
        InfoDocument.Dispose()
        InfoManager.Position = SavedPosition
    End Sub
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        If MessageBox.Show("        " _
        , "Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
            InfoManager.RemoveAt(InfoManager.Position)
            Call ShowPhoto()
        End If
        Call SetState("View")
    End Sub
End Class
